namespace eval num {

# intonations are
# 	term
#		hold
#		rise

proc below100 {i intonation lang} {
	global num
	if {[string range $lang 0 1]=="en"} {
		if {$i<21} {
			return $lang/$i-$intonation
		} else {
			set ret {}
			set i10 [expr 10*($i/10)]
			set i [expr $i-$i10]
			if {$i!=0} {
				lappend ret $lang/$i10-hold
				lappend ret $lang/$i-$intonation
			} else {
				lappend ret $lang/$i10-$intonation
			}
			return $ret
		}
	} elseif {[string range $lang 0 1]=="de"} {
		if {$i<21} {
			return $lang/$i-$intonation
		} else {
			set i10 [expr 10*($i/10)]
			set i [expr $i-$i10]
			if {$i!=0} {
				set ret [concat $lang/$i-hold $lang/and $lang/$i10-$intonation]
			} else {
				set ret [concat $lang/$i10-$intonation]
			}
			return $ret
		}
	} else {
		return ""
	}
}

proc below1000 {i intonation lang} {
	global num
	if {[string range $lang 0 1]=="en"} {
		if {$i<100} {
			return [below100 $i $intonation $lang]
		} else {
			set i100 [expr 100*($i/100)]
			set itmp [expr $i100/100]
			set i [expr $i-$i100]
			if {$i!=0} {
				set ret [concat $lang/$itmp-hold $lang/100-hold $lang/and [below100 $i $intonation $lang]]
				return $ret
			} else {
				set ret [concat $lang/$itmp-hold $lang/100-$intonation]
				return $ret
			}
		}
	} elseif {[string range $lang 0 1]=="de"} {
		if {$i<100} {
			return [below100 $i $intonation $lang]
		} else {
			set i100 [expr 100*($i/100)]
			set itmp [expr $i100/100]
			set i [expr $i-$i100]
			if {$i!=0} {
				set ret [concat $lang/$itmp-hold $lang/100-hold $lang/and [below100 $i $intonation $lang]]
			} else {
				set ret [concat $lang/$itmp-hold $lang/100-$intonation]
			}
		}
	} else {
		return ""
	}
}

proc natnum {i intonation lang} {
	global num
	if {[string range $lang 0 1]=="en"} {
		if {$i<1000} {
			return [below1000 $i $intonation $lang]
		} else {
			set i1000 [expr ($i/1000)]
			set i [expr $i-$i1000*1000]
			if {$i!=0} {
				set ret [concat [below1000 $i1000 hold $lang] $lang/1000-hold $lang/and [below1000 $i $intonation $lang]]
				return $ret
			} else {
				set ret [concat [below1000 $i1000 hold $lang] $lang/1000-$intonation]
				return $ret
			}
		}
	} elseif {[string range $lang 0 1]=="de"} {
		if {$i<1000} {
			return [below1000 $i $intonation $lang]
		} else {
			set i1000 [expr ($i/1000)]
			set i [expr $i-$i1000*1000]
			if {$i!=0} {
				return [concat [below1000 $i1000 hold $lang] $lang/1000-hold $lang/and [below1000 $i $intonation $lang]]
			} else {
				return [concat [below1000 $i1000 hold $lang] $lang/1000-$intonation]
			}
		}
	} else {
		return ""
	}
}

}