#==========================================================================================
#
# 	Written by Richard Breuer (richard.breuer@gmx.de)
#
#==========================================================================================
# Mar 08, 2000	First version [RB]
#==========================================================================================

namespace eval file {

proc forAll {cd cb} {
  eval $cb \"$cd\"

  # recursively step through all subdirs
  if {[catch {set all [glob -nocomplain $cd/*]}]} {set all {}}
  foreach dir $all {
    if {[file isdirectory $dir]} {
      file::forAll $dir $cb
    }
  }
}

proc diff {fn1 fn2} {
  set f [open $fn1 r]
  set g [open $fn2 r]
  fconfigure $f -translation binary
  fconfigure $g -translation binary
  set ret [string compare [read $f] [read $g]]
  close $f
  close $g
  return $ret
}

}